/* A Bison parser, made from parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	NPHOTONS	257
# define	SEED	258
# define	SEGFILE	259
# define	FREQUENCY	260
# define	CLIGHT	261
# define	STIME	262
# define	NTIME	263
# define	DTIME	264
# define	TISSUETYPE	265
# define	MUS	266
# define	MUA	267
# define	G	268
# define	N	269
# define	SOURCE	270
# define	DETECTOR	271
# define	SDPOS	272
# define	SDDIR	273
# define	SDRAD	274
# define	SDNA	275
# define	DX	276
# define	DY	277
# define	DZ	278
# define	IMGX	279
# define	IMGY	280
# define	IMGZ	281
# define	NXSTEP	282
# define	NYSTEP	283
# define	NZSTEP	284
# define	SETFLAG	285
# define	FTWOPT	286
# define	FSMOVE	287
# define	FDMOVE	288
# define	FXMOVE	289
# define	FXTIME	290
# define	FMATLAB	291
# define	FMIRROR	292
# define	FILENAME	293
# define	REALNUMBER	294
# define	DECNUMBER	295

#line 1 "parser.y"

/*
 * This file is part of tMCimg.
 * 
 * tMCimg is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "config.h"
#include "tMCimg.h"

#if (HAVE_ASSERT_H)
#include <assert.h>
#endif

static double tmpmus, tmpmua, tmpn, tmpg;
static double tmppos[3], tmpdir[3], tmprad, tmpna;
static struct Config *config = NULL;
 
void init_config(void);
int  checkconfig(void);
void add_tissue(double mus, double mua, double g, double n);
void add_detector(double r[3], double d[3], double rad, double na);
void   add_source(double r[3], double d[3], double rad, double na);

#define YYDEBUG 0

extern void parsefile(FILE *);
extern int yylex();

void yyerror(const char *s)
{
  extern int linenumber;
  extern char *yytext;

  fprintf(stderr, "%s\n", (s == NULL) ? "" : s);
  fprintf(stderr, "Error on line %d near text \"%s\"\n", 
          linenumber, (yytext == NULL) ? "" : yytext);

  return;
}

#line 60 "parser.y"
#ifndef YYSTYPE
typedef union {
  double      real;
  int         integer;
  const char *string;
  char        character;
  int        *ipointer;
  double     *rpointer;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		99
#define	YYFLAG		-32768
#define	YYNTBASE	46

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 295 ? yytranslate[x] : 59)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    44,     2,    45,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    42,     2,    43,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     7,     9,    11,    13,    15,    17,
      20,    23,    26,    29,    32,    35,    38,    41,    44,    47,
      50,    53,    56,    59,    62,    65,    68,    71,    75,    79,
      83,    87,    91,    95,    99,   102,   105,   108,   111,   114,
     117,   120,   123,   126,   129,   132,   135,   138,   141,   144,
     147,   150,   156,   159,   161,   163
};
static const short yyrhs[] =
{
      -1,    46,    47,     0,    46,     1,     0,    49,     0,    48,
       0,    50,     0,    52,     0,    51,     0,     3,    41,     0,
       4,    41,     0,     5,    39,     0,     6,    58,     0,     7,
      58,     0,     8,    58,     0,    10,    58,     0,     9,    58,
       0,    25,    56,     0,    26,    56,     0,    27,    56,     0,
      22,    58,     0,    23,    58,     0,    24,    58,     0,    28,
      58,     0,    29,    58,     0,    30,    58,     0,    31,    49,
       0,    31,    32,    57,     0,    31,    33,    57,     0,    31,
      34,    57,     0,    31,    35,    57,     0,    31,    36,    57,
       0,    31,    37,    57,     0,    31,    38,    57,     0,    11,
      42,     0,    50,    53,     0,    50,    43,     0,    17,    42,
       0,    51,    54,     0,    51,    43,     0,    16,    42,     0,
      52,    54,     0,    52,    43,     0,    12,    58,     0,    13,
      58,     0,    14,    58,     0,    15,    58,     0,    20,    58,
       0,    21,    58,     0,    18,    55,     0,    19,    55,     0,
      44,    58,    58,    58,    45,     0,    41,    41,     0,    41,
       0,    40,     0,    41,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   125,   126,   127,   129,   130,   131,   132,   133,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   154,   159,   164,
     169,   174,   179,   184,   190,   192,   193,   202,   206,   207,
     210,   214,   215,   218,   219,   220,   221,   223,   224,   225,
     227,   230,   240,   247,   252,   253
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "NPHOTONS", "SEED", "SEGFILE", "FREQUENCY", 
  "CLIGHT", "STIME", "NTIME", "DTIME", "TISSUETYPE", "MUS", "MUA", "G", 
  "N", "SOURCE", "DETECTOR", "SDPOS", "SDDIR", "SDRAD", "SDNA", "DX", 
  "DY", "DZ", "IMGX", "IMGY", "IMGZ", "NXSTEP", "NYSTEP", "NZSTEP", 
  "SETFLAG", "FTWOPT", "FSMOVE", "FDMOVE", "FXMOVE", "FXTIME", "FMATLAB", 
  "FMIRROR", "FILENAME", "REALNUMBER", "DECNUMBER", "'{'", "'}'", "'['", 
  "']'", "input", "statement", "option", "flag", "tissue", "detector", 
  "source", "tissue_prop", "sd_prop", "vector", "range", "bool", "number", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    46,    46,    46,    47,    47,    47,    47,    47,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    49,    49,    49,
      49,    49,    49,    49,    50,    50,    50,    51,    51,    51,
      52,    52,    52,    53,    53,    53,    53,    54,    54,    54,
      54,    55,    56,    57,    58,    58
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     2,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     5,     2,     1,     1,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     0,     3,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     5,     4,     6,     8,     7,
       9,    10,    11,    54,    55,    12,    13,    14,    16,    15,
      34,    40,    37,    20,    21,    22,     0,    17,    18,    19,
      23,    24,    25,     0,     0,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     0,     0,    36,    35,     0,     0,
       0,     0,    39,    38,    42,    41,    52,    53,    27,    28,
      29,    30,    31,    32,    33,    43,    44,    45,    46,     0,
      49,    50,    47,    48,     0,     0,     0,    51,     0,     0
};

static const short yydefgoto[] =
{
       1,    24,    25,    26,    27,    28,    29,    67,    73,    90,
      47,    78,    35
};

static const short yypact[] =
{
  -32768,    16,-32768,   -35,   -29,   -21,   -36,   -36,   -36,   -36,
     -36,    12,    17,    18,   -36,   -36,   -36,    11,    11,    11,
     -36,   -36,   -36,    43,-32768,-32768,-32768,    22,    10,    30,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,    20,-32768,-32768,-32768,
  -32768,-32768,-32768,    34,    21,    21,    21,    21,    21,    21,
      21,-32768,   -36,   -36,   -36,   -36,-32768,-32768,    39,    39,
     -36,   -36,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -36,
  -32768,-32768,-32768,-32768,   -36,   -36,    40,-32768,    84,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,    63,-32768,-32768,-32768,-32768,    60,    27,
      -8,    35,    -7
};


#define	YYLAST		96


static const short yytable[] =
{
      36,    37,    38,    39,    33,    34,    30,    43,    44,    45,
      48,    49,    31,    50,    51,    52,    98,     2,    32,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    68,    69,
      70,    71,    12,    13,    62,    63,    64,    65,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    68,    69,
      70,    71,    46,    72,    40,    85,    86,    87,    88,    41,
      42,    76,    77,    92,    93,    66,    54,    55,    56,    57,
      58,    59,    60,    74,    53,    54,    55,    56,    57,    58,
      59,    60,    94,    89,    99,    97,    61,    95,    96,    75,
      79,    80,    81,    82,    83,    84,    91
};

static const short yycheck[] =
{
       7,     8,     9,    10,    40,    41,    41,    14,    15,    16,
      18,    19,    41,    20,    21,    22,     0,     1,    39,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    18,    19,
      20,    21,    16,    17,    12,    13,    14,    15,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    18,    19,
      20,    21,    41,    43,    42,    62,    63,    64,    65,    42,
      42,    41,    41,    70,    71,    43,    32,    33,    34,    35,
      36,    37,    38,    43,    31,    32,    33,    34,    35,    36,
      37,    38,    89,    44,     0,    45,    23,    94,    95,    29,
      55,    56,    57,    58,    59,    60,    69
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 127 "parser.y"
{ exit(1); ;
    break;}
case 9:
#line 135 "parser.y"
{ config->NT        = yyvsp[0].integer; ;
    break;}
case 10:
#line 136 "parser.y"
{ config->seed      = (long)yyvsp[0].integer; ;
    break;}
case 11:
#line 137 "parser.y"
{ strncpy(config->segFile, yyvsp[0].string, FILENMLEN); ;
    break;}
case 12:
#line 138 "parser.y"
{ config->frequency = yyvsp[0].real; ;
    break;}
case 13:
#line 139 "parser.y"
{ config->v0        = yyvsp[0].real; ;
    break;}
case 14:
#line 140 "parser.y"
{ config->Tmin      = yyvsp[0].real; ;
    break;}
case 15:
#line 141 "parser.y"
{ config->stepT     = yyvsp[0].real; ;
    break;}
case 16:
#line 142 "parser.y"
{ config->nTstep    = (int)yyvsp[0].real; ;
    break;}
case 17:
#line 143 "parser.y"
{ config->Ixmin=(yyvsp[0].ipointer)[0]; config->Ixmax=(yyvsp[0].ipointer)[1]; ;
    break;}
case 18:
#line 144 "parser.y"
{ config->Iymin=(yyvsp[0].ipointer)[0]; config->Iymax=(yyvsp[0].ipointer)[1]; ;
    break;}
case 19:
#line 145 "parser.y"
{ config->Izmin=(yyvsp[0].ipointer)[0]; config->Izmax=(yyvsp[0].ipointer)[1]; ;
    break;}
case 20:
#line 146 "parser.y"
{ config->xstep = yyvsp[0].real; ;
    break;}
case 21:
#line 147 "parser.y"
{ config->ystep = yyvsp[0].real; ;
    break;}
case 22:
#line 148 "parser.y"
{ config->zstep = yyvsp[0].real; ;
    break;}
case 23:
#line 149 "parser.y"
{ config->nxstep=(int)yyvsp[0].real; ;
    break;}
case 24:
#line 150 "parser.y"
{ config->nystep=(int)yyvsp[0].real; ;
    break;}
case 25:
#line 151 "parser.y"
{ config->nzstep=(int)yyvsp[0].real; ;
    break;}
case 27:
#line 154 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set 2pt flag\n");
				 else
				   printf("\t!Config set no-2pt flag\n");
				 config->flags.gen_twopt = yyvsp[0].integer; ;
    break;}
case 28:
#line 159 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set src move flag\n");
				 else
				   printf("\t!Config set no-src move flag\n");
				 config->flags.source_move = yyvsp[0].integer; ;
    break;}
case 29:
#line 164 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set det move flag\n");
				 else
				   printf("\t!Config set no-det move flag\n");
				 config->flags.detector_move = yyvsp[0].integer; ;
    break;}
case 30:
#line 169 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set exit move flag\n");
				 else
				   printf("\t!Config set no-exit move flag\n");
				 config->flags.exiting_move = yyvsp[0].integer; ;
    break;}
case 31:
#line 174 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set exit time flag\n");
				 else
				   printf("\t!Config set exit bin flag\n");
				 config->flags.exact_exit_time = yyvsp[0].integer; ;
    break;}
case 32:
#line 179 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set matlab order flag\n");
				 else
				   printf("\t!Config set C order flag\n");
				 config->flags.matlab_order = yyvsp[0].integer; ;
    break;}
case 33:
#line 184 "parser.y"
{ if (yyvsp[0].integer == 1)
				   printf("\t!Config set mirror BC flag\n");
				 else
				   printf("\t!Config set no-mirror BC flag\n");
				 config->flags.mirror = yyvsp[0].integer; ;
    break;}
case 34:
#line 190 "parser.y"
{ tmpmus = -1; tmpmua = -1; 
                           tmpn   = -1; tmpg   = -1; ;
    break;}
case 36:
#line 193 "parser.y"
{ if ((tmpmus == -1) || (tmpmua == -1) ||
		           (tmpg   == -1) || (tmpn   == -1)) {
                         yyerror("Incompletely initialized tissue type\n");
			 YYABORT;
		       }

		       add_tissue(tmpmus, tmpmua, tmpg, tmpn); 
		     ;
    break;}
case 37:
#line 202 "parser.y"
{ tmppos[0] = tmppos[1] = tmppos[2] = -998;
                         tmpdir[0] = tmpdir[1] = tmpdir[2] = 0.0;
                         tmprad = -1.0;
                         tmpna  =  1.0; ;
    break;}
case 39:
#line 207 "parser.y"
{ add_detector(tmppos, tmpdir, tmprad, tmpna); 
                         tmprad = -1; ;
    break;}
case 40:
#line 210 "parser.y"
{ tmppos[0] = tmppos[1] = tmppos[2] = -998;
                         tmpdir[0] = tmpdir[1] = tmpdir[2] = 0.0;
                         tmprad = 0.0;
                         tmpna  = 0.0; ;
    break;}
case 42:
#line 215 "parser.y"
{ add_source(tmppos, tmpdir, tmprad, tmpna); 
                         tmprad = -1; ;
    break;}
case 43:
#line 218 "parser.y"
{ tmpmus = yyvsp[0].real; ;
    break;}
case 44:
#line 219 "parser.y"
{ tmpmua = yyvsp[0].real; ;
    break;}
case 45:
#line 220 "parser.y"
{ tmpg   = yyvsp[0].real; ;
    break;}
case 46:
#line 221 "parser.y"
{ tmpn   = yyvsp[0].real; ;
    break;}
case 47:
#line 223 "parser.y"
{ tmprad = yyvsp[0].real; ;
    break;}
case 48:
#line 224 "parser.y"
{ tmpna  = yyvsp[0].real; ;
    break;}
case 49:
#line 225 "parser.y"
{ memcpy(tmppos, (double *)yyvsp[0].rpointer, sizeof(tmppos)); 
                          free((double *)yyvsp[0].rpointer); ;
    break;}
case 50:
#line 227 "parser.y"
{ memcpy(tmpdir, (double *)yyvsp[0].rpointer, sizeof(tmpdir));
                          free((double *)yyvsp[0].rpointer); ;
    break;}
case 51:
#line 230 "parser.y"
{
                double *rvec = (double *)malloc(3*sizeof(double));
#if (HAVE_ASSERT_H)
                assert(rvec != NULL);
#endif

                rvec[0] = yyvsp[-3].real; rvec[1] = yyvsp[-2].real; rvec[2] = yyvsp[-1].real;
                yyval.rpointer = rvec;
              ;
    break;}
case 52:
#line 240 "parser.y"
{
		static int drange[2];

		drange[0] = yyvsp[-1].integer;  drange[1] = yyvsp[0].integer;
		yyval.ipointer = drange;
	      ;
    break;}
case 53:
#line 247 "parser.y"
{ if (yyvsp[0].integer == 0)  /* Boolean from integer */
                         { yyval.integer = 0; }
                       else
                         { yyval.integer = 1; } ;
    break;}
case 54:
#line 252 "parser.y"
{ yyval.real =         yyvsp[0].real; ;
    break;}
case 55:
#line 253 "parser.y"
{ yyval.real = (double)yyvsp[0].integer; /* type promotion */ ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 255 "parser.y"


int parseconfig(struct Config *p, FILE *fp)
{
  double dv = 0;

#if (HAVE_ASSERT_H)
  assert(p  != NULL);
  assert(fp != NULL);
#endif

  config = p;

  init_config();                  /* Initialize the memory */

  parsefile(fp);                  /* Read and parse the .inp file */

  /* Compute the various derived quantities */

  config->frequency *= 1.0e6;     /* Convert from MHz */
  config->k0         = 2*PI*config->frequency / config->v0;

  config->Tmax = config->Tmin + config->nTstep * config->stepT;

  /* Image sizes not specified implicitly mean "use all" */

  if ((config->Ixmin == -1) && (config->Ixmax == -1))
    {
      config->Ixmin = 0;
      config->Ixmax = config->nxstep - 1;
    }

  if ((config->Iymin == -1) && (config->Iymax == -1))
    {
      config->Iymin = 0;
      config->Iymax = config->nystep - 1;
    }

  if ((config->Izmin == -1) && (config->Izmax == -1))
    {
      config->Izmin = 0;
      config->Izmax = config->nzstep - 1;
    }

  /* Compute number of voxels in image region */

  config->nIxstep = config->Ixmax - config->Ixmin + 1;
  config->nIystep = config->Iymax - config->Iymin + 1;
  config->nIzstep = config->Izmax - config->Izmin + 1;

  if (config->zstep > dv) dv = config->zstep;
  if (config->ystep > dv) dv = config->ystep;
  if (config->xstep > dv) dv = config->xstep;

  if (dv <= 0) 
    dv = 1.0;           /* default when no length specified */

  config->dl = dv;

  /* Back-fill any missing lengths (implicitly the largest one) */

  if (config->xstep <= 0.0) config->xstep = config->dl;
  if (config->ystep <= 0.0) config->ystep = config->dl;
  if (config->zstep <= 0.0) config->zstep = config->dl;

  /* Calculate min and max photon lengths from the min and max
     propagation times in vacuuo */

  if (checkconfig() != 0)         /* Sanity check the final configuration */
    return 2;

  return 0;                       /* Done */
}

void init_config(void)
{
  int i;
#if (YYDEBUG)
  extern int yydebug;

  yydebug = 1;
#endif

  /* Set default configuration */

  config->v0 = C_VACUUM;

  config->xstep = config->ystep = config->zstep = -1;

  config->segFile[0] = '\0';

  config->Ixmin = -1;  config->Ixmax = -1;
  config->Iymin = -1;  config->Iymax = -1;
  config->Izmin = -1;  config->Izmax = -1;

  config->Ntissue = 0;

  for (i = 0; i < MAXTISSUE; i++)
    {
      config->tmus[i] = MUS_AIR;
      config->tmua[i] = MUS_AIR;
      config->tg[i]   =   G_AIR;
      config->tn[i]   = IDX_AIR;
    }

  config->nDets = 0;

  for (i = 0; i < MAXDET; i++)
    {
      config->detLoc[i][0] = -1;
      config->detLoc[i][1] = -1;
      config->detLoc[i][2] = -1;

      config->detDir[i][0] = -1;
      config->detDir[i][1] = -1;
      config->detDir[i][2] = -1;

      config->detRad[i]    = -1;
      config->detNA[i]     = -1;
    }

  config->nSrcs = 0;

  for (i = 0; i < MAXDET; i++)
    {
      config->srcLoc[i][0] = -1;
      config->srcLoc[i][1] = -1;
      config->srcLoc[i][2] = -1;

      config->srcDir[i][0] = -1;
      config->srcDir[i][1] = -1;
      config->srcDir[i][2] = -1;

      config->srcRad[i]    = -1;
      config->srcNA[i]     = -1;
    }

  return;
}

void add_tissue(double mus, double mua, double tg, double tn)
{
  int n = ++config->Ntissue;

  config->tmus[n] = mus;
  config->tmua[n] = mua;
  config->tg[n]   = tg;
  config->tn[n]   = tn;

  return;
}

/* Add a new detector entry based on the supplied detector parameters */

void add_detector(double r[3], double d[3], double rad, double na)
{
  double nrm = sqrt(d[0]*d[0] + d[1]*d[1] + d[2]*d[2]);
  int      n = config->nDets;

#if (HAVE_ASSERT_H)
  assert((n >= 0) && (n < MAXDET));
#endif

  if ((r[0] == -998) && (r[1] == -998) && (r[2] == -998)) 
    {
      yyerror("Detector position not defined\n");
      exit(1);
    }
  else
    {
      config->detLoc[n][0] = r[0];
      config->detLoc[n][1] = r[1];
      config->detLoc[n][2] = r[2];
    }

  if (nrm > 0)
    {
      /* Turn direction into a unit vector */

      config->detDir[n][0] = d[0]/nrm;
      config->detDir[n][1] = d[1]/nrm;
      config->detDir[n][2] = d[2]/nrm;
    }
  else
    {
      config->detDir[n][0] = 0;
      config->detDir[n][1] = 0;
      config->detDir[n][2] = 0;
    }

  if (rad <= 0)
    {
      yyerror("Detector radius non-positive or not defined");
      exit(1);
    }
  else
    config->detRad[n] = rad;

  if (na < 0)
    {
      yyerror("Detector NA must be non-negative");
      exit(1);
    }
  else if (na > 1)
    {
      yyerror("Source NA too large");
      exit(1);
    }
  else
    config->detNA[n] = na;

  ++config->nDets;

  return;
}

void add_source(double r[3], double d[3], double rad, double na)
{
  double nrm = sqrt(d[0]*d[0] + d[1]*d[1] + d[2]*d[2]);
  int      n = config->nSrcs;

#if (HAVE_ASSERT_H)
  assert((n >= 0) && (n < MAXDET));
#endif

  if ((r[0] == -998) && (r[1] == -998) && (r[2] == -998)) 
    {
      yyerror("Source position not defined\n");
      exit(1);
    }
  else
    {
      config->srcLoc[n][0] = r[0];
      config->srcLoc[n][1] = r[1];
      config->srcLoc[n][2] = r[2];
    }

  if (nrm > 0)
    {
      /* Turn direction into a unit vector */

      config->srcDir[n][0] = d[0]/nrm;
      config->srcDir[n][1] = d[1]/nrm;
      config->srcDir[n][2] = d[2]/nrm;
    }
  else
    {
      yyerror("Source direction zeros or not defined\n");
      exit(1);
    }

  if (rad < 0)
    {
      yyerror("Source radius negative or not defined");
      exit(1);
    }
  else
    config->srcRad[n] = rad;

  if (na < 0)
    {
      yyerror("Source NA must be non-negative");
      exit(1);
    }
  else if (na > PI/2)
    {
      yyerror("Source NA too large");
      exit(1);
    }
  else
    config->srcNA[n] = na;

  ++config->nSrcs;

  return;
}

#define PARSE_ERROR(s) { printf("Input error: %s\n", (s)); return 1; }
#define PARSE_WARN(s)  { printf("Warning: %s\n", (s)); }

int checkconfig(void)
{
  int i;

  if ((config->frequency > 1.0e10) || (config->frequency < -1.0e10))
    printf("Warning: abnormally large frequency reqested (%f MHz)\n",
           config->frequency * 1e-6);

  if ((config->nTstep <= 0) || (config->stepT <= 0))
    PARSE_ERROR("Non-causal time steps not allowed");

  if ((config->xstep <= 0) || (config->ystep <= 0) || (config->zstep <= 0))
    PARSE_ERROR("xstep, ystep, and zstep must be strictly positive");

  if ((config->xstep != config->ystep) || (config->xstep != config->zstep))
    PARSE_ERROR("xstep == ystep == zstep required in this version");

  if ((config->Ixmin < 0) || (config->nIxstep > config->nxstep))
    PARSE_ERROR("Illegal image size (X dimension)");

  if ((config->Iymin < 0) || (config->nIystep > config->nystep))
    PARSE_ERROR("Illegal image size (Y dimension)");

  if ((config->Izmin < 0) || (config->nIzstep > config->nzstep))
    PARSE_ERROR("Illegal image size (Z dimension)");

  if (config->Ntissue >= MAXTISSUE)
    PARSE_ERROR("Too many tissue types");

  for (i = 1; i <= config->Ntissue; i++)
    {
      if (config->tmus[i] == 0)
        PARSE_WARN("Zero scattering coefficient");
      if (config->tmus[i] <  0)
        PARSE_ERROR("Non-physical scattering coefficient");
      if (config->tmua[i] <  0)
        PARSE_ERROR("Non-physical absorption coefficient");
      if ((config->tg[i] < -0.5) || (config->tg[i] > 1.0))
        PARSE_ERROR("Non-physical anisotropy coefficient");
      if (config->tn[i] <= 0)
        PARSE_ERROR("Non-physical index of refraction");

      if (config->tn[i] < 1.0)
        PARSE_WARN(
          "Index of refraction < 1, I hope you know what you're doing!\n");
    }

  if (config->nSrcs <= 0)
    PARSE_ERROR("No Source Specified");

  for (i = 0; i < config->nSrcs; i++)
    if ((config->srcLoc[i][0] < 0) ||
	(config->srcLoc[i][1] < 0) ||
	(config->srcLoc[i][2] < 0) ||
	(config->srcLoc[i][0] >= config->nxstep * config->xstep) ||
	(config->srcLoc[i][1] >= config->nystep * config->ystep) ||
	(config->srcLoc[i][2] >= config->nzstep * config->zstep))
      {
	PARSE_WARN("Source located outside of image volume");
	fprintf(stderr, "\tr = [ %f,%f,%f ]\n", config->srcLoc[i][0],
		config->srcLoc[i][1], config->srcLoc[i][2]);
      }

  for (i = 0; i < config->nDets; i++)
    if ((config->detLoc[i][0] < 0) ||
	(config->detLoc[i][1] < 0) ||
	(config->detLoc[i][2] < 0) ||
	(config->detLoc[i][0] >= config->nxstep * config->xstep) ||
	(config->detLoc[i][1] >= config->nystep * config->ystep) ||
	(config->detLoc[i][2] >= config->nzstep * config->zstep))
      {
	PARSE_WARN("Detector located outside of image volume");
	fprintf(stderr, "\tr = [ %f,%f,%f ]\n", config->detLoc[i][0],
		config->detLoc[i][1], config->detLoc[i][2]);
      }

  return 0;
}
